//+------------------------------------------------------------------+
//|                                               BullAndBear_v1.mq4 |
//|                                  Copyright  2006, Forex-TSD.com |
//|                         Written by IgorAD,igorad2003@yahoo.co.uk |   
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |                                      
//+------------------------------------------------------------------+
//| BullAndBear_TRO_MODIFIED_VERSION                                 |
//| MODIFIED BY AVERY T. HORTON, JR. AKA THERUMPLEDONE@GMAIL.COM     |
//| I am NOT the ORIGINAL author 
//  and I am not claiming authorship of this indicator. 
//  All I did was modify it. I hope you find my modifications useful.|
//|                                                                  |
//+------------------------------------------------------------------+
 
#property copyright "Copyright  2006, Forex-TSD.com "
#property link      "http://www.forex-tsd.com/"

#property indicator_separate_window
#property indicator_buffers 2

#property indicator_color1 SkyBlue
#property indicator_width1 2
#property indicator_color2 Tomato
#property indicator_width2 0
#property indicator_style2 2



extern bool Sound.Alert = true ;
extern bool Show.Message = true ;

extern int myCorner= 1;
extern int x.offset= 80 ; 
extern int y.offset= 10 ; 


extern string myFont       = "Arial Bold" ;
extern int    myFontSize   = 20 ;

extern color colorUp  =  Lime ;
extern color colorxUp =  Blue ;
extern color colorEq  =  DimGray ;
extern color colorxDn =  Magenta ;
extern color colorDn  =  Red ;

//---- input parameters
extern int     Length         = 20;  // Period of BullAndBear
extern int     Smooth         = 5;   // Period of Smoothing MA  
extern int     Signal         = 5;   // Period of Signal MA 
//---- indicator buffers
double BullnBear[];
double Sig[];
double Bulls[];
double Bears[];
double AvgBulls[];
double AvgBears[];
double Diff[];

int    digits2, digits, period, win , xInc, yInc, xPos, yPos  ; 
string short_name;
 
string symbol, tChartPeriod, tAlert, tObjName06 ; 
double   point ;    
color colorPrice ;
datetime Trigger ;

//+------------------------------------------------------------------+
  int init()
  {
  
   period       =  Period() ;  
   tChartPeriod =  TimeFrameToString(period) ;
   symbol       =  Symbol() ;
   digits       =  Digits ;   
   point        =  Point ;

   if(digits == 5 || digits == 3) { digits = digits - 1 ; point = point * 10 ; } 
  
  
   IndicatorBuffers(7);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,BullnBear);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,Sig);
   SetIndexBuffer(2,Bulls);
   SetIndexBuffer(3,Bears);
   SetIndexBuffer(4,AvgBulls);
   SetIndexBuffer(5,AvgBears);
   SetIndexBuffer(6,Diff); 

//---- indicator line
   
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
//---- name for DataWindow and indicator subwindow label
   short_name="BullAndBear("+Length+","+Smooth+","+Signal+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,"BullAndBear");
   SetIndexLabel(1,"Signal");
//----
    
   SetIndexDrawBegin(0,3*(Length+Smooth+Signal));
   SetIndexDrawBegin(1,3*(Length+Smooth+Signal));
//----
   SetLevelStyle(STYLE_DOT, 1, DimGray) ;
   SetLevelValue(1,200);
   SetLevelValue(2,100);   
   SetLevelValue(3,50);
   SetLevelValue(4,0);
   SetLevelValue(5,-50);
   SetLevelValue(6,-100);
   SetLevelValue(7,-200);  
    
   tObjName06 = short_name + "06" ; 
    
   return(0);
  }

//+------------------------------------------------------------------+
//| BullAndBear_v1                                                   |
//+------------------------------------------------------------------+
int start()
{

   win =    WindowFind(short_name);
    
   int    i,shift, counted_bars=IndicatorCounted(),limit;
   double price;      
   if ( counted_bars > 0 )  limit=Bars-counted_bars;
   if ( counted_bars < 0 )  return(0);
   if ( counted_bars ==0 )  limit=Bars-1; 
   if ( counted_bars < 1 ) 
   
   for(i=1;i<Length+Smooth+Signal;i++) 
   {
   BullnBear[Bars-i]=(Close[Bars-i]-Open[Bars-i])/Point;    
   Sig[Bars-i]=(Close[Bars-i]-Open[Bars-i])/Point;  
   }
   
   for(shift=limit;shift>=0;shift--) 
   {	
   
      if (Close[shift] < Open[shift])
      {
         if (Close[shift+1] < Open[shift])
         Bulls[shift] = MathMax(High[shift] - Close[shift+1], Close[shift] - Low[shift]);
         else
         Bulls[shift] = MathMax(High[shift] - Open[shift], Close[shift] - Low[shift]);
      }
      else
      if( Close[shift] > Open[shift] )
      { 
         if (Close[shift+1] > Open[shift])
         Bulls[shift] = High[shift] - Low[shift];
         else
         Bulls[shift] = MathMax(Open[shift] - Close[shift+1], High[shift] - Low[shift]);
      }
      else
      if( High[shift] - Close[shift] > Close[shift] - Low[shift] ) 
      {
         if (Close[shift+1] < Open[shift])
         Bulls[shift] = MathMax( High[shift] -  Close[shift+1],Close[shift] - Low[shift]);
         else
         Bulls[shift] = High[shift] - Open[shift];
      }
      else
      if( High[shift] - Close[shift] < Close[shift] - Low[shift])
      {
         if (Close[shift+1] > Open[shift])
         Bulls[shift] = High[shift] - Low[shift];
         else
         Bulls[shift]= MathMax(Open[shift] - Close[shift+1],High[shift] - Low[shift]);
      }
      else
      if (Close[shift+1] > Open[shift])
      Bulls[shift] = MathMax(High[shift] - Open[shift],Close[shift] - Low[shift]);
      else
      if (Close[shift+1] < Open[shift])
      Bulls[shift] = MathMax( Open[shift]- Close[shift+1], High[shift] - Low[shift]);
      else
      Bulls[shift] = High[shift] - Low[shift];
   
      
      
      if(Close[shift] < Open[shift])
      {
         if(Close[shift+1]>Open[shift])
         Bears[shift] = MathMax(Close[shift+1]- Open[shift],High[shift] - Low[shift]);
         else
         Bears[shift] = High[shift] - Low[shift];
      }   
      else
      if(Close[shift] > Open[shift])
      {
         if (Close[shift+1] > Open[shift])
         Bears[shift] = MathMax( Close[shift+1] - Low[shift],High[shift]- Close[shift]);
         else
         Bears[shift] = MathMax(Open[shift]- Low[shift],High[shift]- Close[shift]);
      }
      else
      if (High[shift] - Close[shift] > Close[shift] - Low[shift])
      {
         if (Close[shift+1] > Open[shift]) 
         Bears[shift] = MathMax(Close[shift+1]-Open[shift],High[shift] - Low[shift]);
         else
         Bears[shift] = High[shift] - Low[shift];
      }
      else
      if (High[shift] - Close[shift] < Close[shift] - Low[shift])
      {
         if (Close[shift+1]>Open[shift])
         Bears[shift] = MathMax(Close[shift+1]-Low[shift],High[shift]-Close[shift]);
         else
         Bears[shift] = Open[shift] - Low[shift];
      }  
      else
      if (Close[shift+1] > Open[shift])
      Bears[shift] = MathMax(Close[shift+1]-Open[shift],High[shift]-Low[shift]);
      else
      if (Close[shift+1]<Open[shift])
      Bears[shift] = MathMax(Open[shift] - Low[shift], High[shift] - Close[shift]);
      else
      Bears[shift] = High[shift] - Low[shift];
   }      
      
   for(shift=limit;shift>=0;shift--)
   { 
   AvgBulls[shift] = iMAOnArray(Bulls,0,Length,0,1,shift)/Point;  
   AvgBears[shift] = iMAOnArray(Bears,0,Length,0,1,shift)/Point;
   Diff[shift] = AvgBulls[shift] - AvgBears[shift];
   }
    
   for(shift=limit;shift>=0;shift--)
   BullnBear[shift] = iMAOnArray(Diff,0,Smooth,0,1,shift);   

   for(shift=limit;shift>=0;shift--)
   Sig[shift] = iMAOnArray(BullnBear,0,Signal,0,1,shift);  
//----

   if(  Show.Message ) { DoShow() ; }

	return(0);	
}


//+------------------------------------------------------------------+

void DoShow()
{
   
   yInc = myFontSize + 5 ;
   yPos = 0 ;
 
   while(true)
   {  
 
   if(BullnBear[0] > Sig[0] && BullnBear[1] < Sig[1]) 
   { 
      colorPrice = colorxUp ;
      tAlert     = tChartPeriod + " Bullish Cross" ; 
      if ( Trigger != Time[0] &&  Sound.Alert ) 
      {
         Trigger = Time[0] ; 
         Alert(symbol,"  ", tChartPeriod, " Bullish Cross " ) ;  
      }

      break ;
   } 
    
   if(BullnBear[0] < Sig[0] && BullnBear[1] > Sig[1]) 
   {  
      colorPrice = colorxDn ;
      tAlert     = tChartPeriod + " Bearish Cross" ; 
      if ( Trigger != Time[0] &&  Sound.Alert ) 
      {
         Trigger = Time[0] ; 
         Alert(symbol,"  ", tChartPeriod, " Bearish Cross " ) ;  
      }
      break ;
   }
   
   if(BullnBear[0] > Sig[0]  ) 
   { 
      colorPrice = colorxUp ;
      tAlert     = tChartPeriod + " Bullish " ; 
      break ;
   } 
       
   if(BullnBear[0] < Sig[0] ) 
   { 
      colorPrice = colorDn ;
      tAlert     = tChartPeriod +  " Bearish " ; 
      break ;
   }  
  
      colorPrice = colorEq ;
      tAlert     = "No Signal" ; 
      break ;
  
   } 

   
   ObjectCreate(tObjName06, OBJ_LABEL, win, 0, 0);// 
   ObjectSetText(tObjName06, tAlert , myFontSize, myFont, colorPrice );  
   ObjectSet(tObjName06, OBJPROP_CORNER, 1);
   ObjectSet(tObjName06, OBJPROP_XDISTANCE,  x.offset); // myCorner
   ObjectSet(tObjName06, OBJPROP_YDISTANCE,  y.offset); //     


}    
      
//+------------------------------------------------------------------+ 

string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN";
   }
   return(tfs);
}
//+------------------------------------------------------------------+  

