//+------------------------------------------------------------------+ 
//|   TRO_MA_DMI_TRIGGER                                             | 
//|                                                                  | 
//|   Copyright  2009, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+ 
//| Use http://therumpledone.mbtrading.com/fx/ as your forex broker  |  
//| ...tell them therumpledone sent you!                             |  
//+------------------------------------------------------------------+ 


#property  copyright "Copyright  2009, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 
  

#property indicator_chart_window
#property indicator_buffers 5
#property indicator_color1 Orange
#property indicator_color2 Red
#property indicator_color3 Green
#property indicator_color4 LimeGreen
#property indicator_color5 OrangeRed
 
extern bool   Send.Mail      = false ;
extern bool   Sound.Alert    = true ;

extern int MA_Period  = 30;
extern int MA_Method  = 1;
extern int DMI_Period = 14;
extern int mySize     = 3 ;

//+------------------------------------------------------------------+

double BUFFER[];
double BUFFER1[];
double BUFFER2[];
double BUFFER3[];
double BUFFER4[];

double MA[];
double DMIP[];
double DMIM[];
 

int CountedBars=0;
 
   int    draw_begin;
   string short_name="MA_DMI_TRIGGER";
   
 int INDEX2, INDEX, i,IDX ;   
    
bool dmipCrossAbove,  dmipCrossBelow, CloseCrossAbove,  CloseCrossBelow ;   

bool DMILONG, DMISHORT , CloseLONG, CloseSHORT ;

bool AlertLong, AlertShort ; 


int    digits, period  ; 
string symbol, tChartPeriod ;  
double point;  
datetime Trigger ;  
    
//+------------------------------------------------------------------+
int init()
  {

   period       =  Period() ;    
   symbol       =  Symbol() ;
   digits       =  Digits ;   
   point        =  Point ;
   
   if(digits == 5 || digits == 3) { digits = digits - 1 ; point = point * 10 ; }   
   
   tChartPeriod =  TimeFrameToString(period) ; 

   SetIndexStyle(0,DRAW_NONE);
   SetIndexStyle(1,DRAW_NONE);
   SetIndexStyle(2,DRAW_NONE);  
   SetIndexStyle(3,DRAW_ARROW,0,mySize);    
   SetIndexStyle(4,DRAW_ARROW,0,mySize); 
      
   SetIndexBuffer(0,MA);
   SetIndexBuffer(1,DMIP);
   SetIndexBuffer(2,DMIM);  
   SetIndexBuffer(3,BUFFER3);  
   SetIndexBuffer(4,BUFFER4); 
   
   SetIndexArrow(3, 233); // UP
   SetIndexArrow(4, 234); // DN
   
   TRO() ;     
          
   return(0);
  }
                                     
//+------------------------------------------------------------------+
int start()
  {
//   if(Bars<=MA_Period) return(0);
   
   CountedBars=IndicatorCounted();  
   
   if (CountedBars<0) return(-1);

   if (CountedBars>0) CountedBars--;

   IDX = Bars - CountedBars - 1 ;
   
   if(IDX < MA_Period) { IDX = MA_Period; }
 
   while(IDX>=0)
   {
      AlertLong    = false  ;
      AlertShort   = false  ;          
      
      BUFFER3[IDX] = EMPTY_VALUE ;
      BUFFER4[IDX] = EMPTY_VALUE ;
     
      MA[IDX]    =  iMA(NULL,0,MA_Period,0,MA_Method,0,IDX) ;   
      DMIP[IDX]  =  iADX(NULL,0,DMI_Period,PRICE_HIGH,MODE_PLUSDI,IDX) ;
      DMIM[IDX]  =  iADX(NULL,0,DMI_Period,PRICE_HIGH,MODE_MINUSDI,IDX) ;       
      
      dmipCrossAbove  = DMIP[IDX] > DMIM[IDX] && DMIP[IDX+1] < DMIM[IDX+1]  ;
      dmipCrossBelow  = DMIP[IDX] < DMIM[IDX] && DMIP[IDX+1] > DMIM[IDX+1]  ;
      
      CloseCrossAbove  = Close[IDX] > MA[IDX] && Close[IDX+1] < MA[IDX+1]  ;
      CloseCrossBelow  = Close[IDX] < MA[IDX] && Close[IDX+1] > MA[IDX+1]  ;      
         
      if( dmipCrossAbove ) { DMILONG = true  ; DMISHORT = false ; }   
      if( dmipCrossBelow ) { DMILONG = false ; DMISHORT = true  ; }   
         
      if( CloseCrossAbove ) { CloseLONG = true  ; CloseSHORT = false ; }   
      if( CloseCrossBelow ) { CloseLONG = false ; CloseSHORT = true  ; }  
               
      if( DMILONG   && CloseLONG  ) 
      {  
         BUFFER3[IDX] = Low[IDX] ;
         AlertLong    = true  ;
         CloseLONG    = false ; 
         DMILONG      = false ;
      }
      
      if( DMISHORT  && CloseSHORT ) 
      { 
         BUFFER4[IDX] = High[IDX] ; 
         AlertShort   = true  ;         
         CloseSHORT   = false ; 
         DMISHORT     = false ;
      }           
               
 	   IDX--;
     }
 
     DoAlert() ;  
 
   return(0);
  }

//+------------------------------------------------------------------+
void DoAlert()    
{
if ( Trigger != Time[0] ) 
{
  if( Sound.Alert )
  {
    if( AlertLong  ) { Trigger = Time[0] ; Alert(symbol,"  ",  " MA_DMI_TRIGGER Long " + DoubleToStr(Close[0] ,digits)); }
    if( AlertShort ) { Trigger = Time[0] ; Alert(symbol,"  ",  " MA_DMI_TRIGGER Short "+ DoubleToStr(Close[0] ,digits)); }     
  }
  
  if( Send.Mail )
  {
    if( AlertLong  ) { Trigger = Time[0] ; SendMail(symbol,  "MA_DMI_TRIGGER Long "); }
    if( AlertShort ) { Trigger = Time[0] ; SendMail(symbol,  "MA_DMI_TRIGGER Short "); }     
  }  
} // if

}

//+--------- TRO MODIFICATION ---------------------------------------+  

string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN";
   }
   return(tfs);
}
//+------------------------------------------------------------------+  
void TRO()
{   
   
   string tObjName03    = "TROTAG"  ;  
   ObjectCreate(tObjName03, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(tObjName03, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(tObjName03, OBJPROP_CORNER, 3);
   ObjectSet(tObjName03, OBJPROP_XDISTANCE, 5 );
   ObjectSet(tObjName03, OBJPROP_YDISTANCE, 5 );  
}

//+------------------------------------------------------------------+

/*

   Comment
   ( 
      "INDEX2 ", INDEX2 , "\n",
      "BUFFER1[0]", DoubleToStr(BUFFER1[0],0) , "\n",
      "BUFFER1[1]", DoubleToStr(BUFFER1[1],0) , "\n",
      "BUFFER1[2]", DoubleToStr(BUFFER1[2],0) , "\n",
      "\n",
      "BUFFER2[0]", DoubleToStr(BUFFER2[0],0) , "\n",
      "BUFFER2[1]", DoubleToStr(BUFFER2[1],0) , "\n",
      "BUFFER2[2]", DoubleToStr(BUFFER2[2],0) , "\n",
   
   "") ; 
   
*/