//+------------------------------------------------------------------+ 
//|   TRO_UpperTrendLineAlert                                        | 
//|                                                                  | 
//|   Copyright  2009, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+ 
//| Use http://therumpledone.mbtrading.com/fx/ as your forex broker  |  
//| ...tell them therumpledone sent you!                             |  
//+------------------------------------------------------------------+ 

#property  copyright "Copyright  2009, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 

#property indicator_chart_window
//+------------------------------------------------------------------+

extern bool   NewTrendLine = true ; 

extern bool   Show.Gauge   = true ; 
extern bool   Show.Comment = true ; 
extern bool   Show.Fibs    = true ; 


extern bool   Sound.Alert  = true ; 

extern int myChartX   = 10 ;
extern int myChartY   = 300 ;  
  
extern int myCorner   = 1 ;
extern string myFont  = "Courier New" ;
extern int myFontSize = 12 ;


//extern string myUpperTrendLineName  = "UpperTrendLine001";
extern color  myUpperTrendLineColor = DeepPink; 
extern int    myUpperTrendLineStyle = STYLE_SOLID;
extern int    myUpperTrendLineWidth = 2;
extern string myUpperSoundFile      = "ahooga.wav";


//extern string myLowerTrendLineName  = "LowerTrendLine001";
extern color  myLowerTrendLineColor = DeepSkyBlue; 
extern int    myLowerTrendLineStyle = STYLE_SOLID;
extern int    myLowerTrendLineWidth = 2;
extern string myLowerSoundFile      = "siren.wav";

extern int    myThreshold      = 1;

extern int  ShiftLabel =  10 ;
extern double    iLevel1 = 0.24; 
extern double    iLevel2 = 0.382; 
extern double    iLevel3 = 0.5; 
extern double    iLevel4 = 0.618; 
extern double    iLevel5 = 0.76; 

extern color Fibcolor1 = DarkSeaGreen ;
extern color Fibcolor2 = Khaki ;
extern color Fibcolor3 = Gray ;
extern color Fibcolor4 = Khaki ;
extern color Fibcolor5 = DarkSeaGreen ; 

 
//+------------------------------------------------------------------+
string symbol, tChartPeriod,  tShortName, TAG="TrendLine", ShortName ;  
int    digits, period, digits2  ; 
double point ;

string OBJ001, OBJ002 ; 
string lbl[15], lbl2[15];

double UpperTrendLinePrice, LowerTrendLinePrice, UpperLimit, LowerLimit, xThreshold;

double  close,  UpperPipDiff,  LowerPipDiff ;

int n, j, k ;
int FillAmt = 11 , x001, x002, x003, x004, x005, x006, x007 ;  

color pColor = Blue  ;

double range ;
double xfb1; 
double xfb2; 
double xfb3; 
double xfb4; 
double xfb5; 

//+------------------------------------------------------------------+
int init()
{

   period       =  Period() ;    
   symbol       =  Symbol() ;
   digits       =  Digits ;   
   point        =  Point ;

   if(digits == 5 || digits == 3) { digits = digits - 1 ; point = point * 10 ; }   
   
   tChartPeriod =  TimeFrameToString(period) ;
    
   ShortName    = TAG + symbol ;
   OBJ001       = TAG + "001";
   OBJ002       = TAG + "002";
     
   xThreshold   = myThreshold * point ;

if( myCorner == 0 || myCorner == 2 )
{ 
   x001 = 0 ;
   x002 = 0 ;
   x003 = 90 ; 
   x004 = 150;
   x005 = 100 ;
   x006 = 90 ;  
   x007 = 90 ;
   FillAmt = 20 ;     
}
else
{
   x001 = 0 ;
   x002 = 130 ; //  
   x003 = 50 ;  //  
   x004 = 0 ; //  
   x005 = 10 ;
   x006 = 10 ;  
   x007 = 10 ;   
   FillAmt = 20 ; 
}
        
  
   deinit(); 
     
   return(0);
}


//+------------------------------------------------------------------+

void ObDeleteObjectsByPrefix(string Prefix)
{
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal())
     {
       string ObjName = ObjectName(i);
       if(StringSubstr(ObjName, 0, L) != Prefix) 
         { 
           i++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
}
    
//+------------------------------------------------------------------+
int deinit()
{
   Comment("") ;
       
   if(NewTrendLine) { ObDeleteObjectsByPrefix(TAG);  }
   
   TRO() ;
   
   return(0);
}
  

//+------------------------------------------------------------------+ 
    
int start()
{
      
      if(ObjectFind(OBJ001) == -1)
      {    
      ObjectCreate(OBJ001, OBJ_TREND, 0, Time[20], High[5], Time[1], High[5]);
      ObjectSet(OBJ001, OBJPROP_STYLE, myUpperTrendLineStyle);
      ObjectSet(OBJ001, OBJPROP_WIDTH, myUpperTrendLineWidth);
      ObjectSet(OBJ001, OBJPROP_COLOR, myUpperTrendLineColor);
      }

      if(ObjectFind(OBJ002) != 0)
      {   
      ObjectCreate(OBJ002, OBJ_TREND, 0, Time[20], Low[5], Time[1], Low[5]);
      ObjectSet(OBJ002, OBJPROP_STYLE, myLowerTrendLineStyle);
      ObjectSet(OBJ002, OBJPROP_WIDTH, myLowerTrendLineWidth);
      ObjectSet(OBJ002, OBJPROP_COLOR, myLowerTrendLineColor);
      }
      
      UpperTrendLinePrice = ObjectGetValueByShift(OBJ001, 0);
      
      LowerTrendLinePrice = ObjectGetValueByShift(OBJ002, 0);
           
      UpperLimit = Ask + xThreshold ;
      LowerLimit = Bid - xThreshold ;




   if(Sound.Alert)
   {      
      if( UpperTrendLinePrice >= LowerLimit && UpperTrendLinePrice <= UpperLimit )
      {
         PlaySound(myUpperSoundFile);
      } 
      
      if( LowerTrendLinePrice >= LowerLimit && LowerTrendLinePrice <= UpperLimit )
      {
         PlaySound(myLowerSoundFile);
      } 
   } // if   
      
n       = 10;
j       = 0 ;

close        = iClose( symbol, 0, 0) ;
UpperPipDiff = ( close - UpperTrendLinePrice ) / point ; 
LowerPipDiff = ( close - LowerTrendLinePrice ) / point ; 

if(Show.Gauge) 
{
lbl[j]  = ShortName+j;
lbl2[j] = fFill(tChartPeriod + " TrendLine Value +/-", 22) ;
DoShowHead(j, SteelBlue);


j       = j + 1 ;
lbl[j]  = ShortName+j;
lbl2[j] = "Upper T/L" ;
DoColor( UpperPipDiff, 0  ) ; 
DoShow(j, myUpperTrendLineColor, UpperTrendLinePrice, UpperPipDiff ); 


j       = j + 1 ;
lbl[j]  = ShortName+j;
lbl2[j] = "Lower T/L" ;
DoColor( LowerPipDiff, 0   ) ; 
DoShow(j, myLowerTrendLineColor, LowerTrendLinePrice, LowerPipDiff );  
 
} // if
   

if(Show.Fibs) DoShowFibs() ;
   
if(Show.Comment) 
{
Comment(
 
"Upper Trend Line Price = " , DoubleToStr(UpperTrendLinePrice,Digits) , "\n" ,
"Lower Trend Line Price = " , DoubleToStr(LowerTrendLinePrice,Digits) , "\n" ,   
"Ask Price = " , DoubleToStr(Ask,Digits) , "\n" ,
"Bid Price = " , DoubleToStr(Bid,Digits) , "\n" ,
"Pips to Upper T/L = " , DoubleToStr(UpperPipDiff,Digits)  , "\n" , 
"Pips to Lower T/L = " , DoubleToStr(LowerPipDiff,Digits)  , "\n" , 
"") ;    
} // if
  
   WindowRedraw();
   
   return(0);
}




//+------------------------------------------------------------------+
  
void DoShowFibs()
{   

            range = UpperTrendLinePrice - LowerTrendLinePrice; 
            xfb1  = UpperTrendLinePrice - range*iLevel1; 
            xfb2  = UpperTrendLinePrice - range*iLevel2; 
            xfb3  = UpperTrendLinePrice - range*iLevel3; 
            xfb4  = UpperTrendLinePrice - range*iLevel4; 
            xfb5  = UpperTrendLinePrice - range*iLevel5; 


 drawLine(xfb1,TAG+"Fib1", Fibcolor1, 2,""+DoubleToStr(iLevel5*100,1 ) + "% "+DoubleToStr(xfb1,digits) ) ; 
 drawLine(xfb2,TAG+"Fib2", Fibcolor2, 2,""+DoubleToStr(iLevel4*100,1 ) + "% "+DoubleToStr(xfb2,digits) ) ; 
 drawLine(xfb3,TAG+"Fib3", Fibcolor3, 2,""+DoubleToStr(iLevel3*100,1 ) + "% "+DoubleToStr(xfb3,digits) ) ; 
 drawLine(xfb4,TAG+"Fib4", Fibcolor4, 2,""+DoubleToStr(iLevel2*100,1 ) + "% "+DoubleToStr(xfb4,digits) ) ; 
 drawLine(xfb5,TAG+"Fib5", Fibcolor5, 2,""+DoubleToStr(iLevel1*100,1 ) + "% "+DoubleToStr(xfb5,digits) ) ; 
  

   return(0);
}


//+------------------------------------------------------------------+
void drawLine(double lvl,string name, color Col,int type,string text)
{
         if(ObjectFind(name) != 0)
         {
            ObjectCreate(name, OBJ_TREND, 0, Time[0], lvl,Time[1],lvl);
            
            if(type == 1)
            ObjectSet(name, OBJPROP_STYLE, STYLE_SOLID);
            else
            ObjectSet(name, OBJPROP_STYLE, STYLE_DOT);
            
            ObjectSet(name, OBJPROP_COLOR, Col);
            ObjectSet(name,OBJPROP_WIDTH,1);
            ObjectSet(name,OBJPROP_RAY,true);
            
         }
         else
         {
            ObjectDelete(name);
            ObjectCreate(name, OBJ_TREND, 0, Time[0], lvl,Time[1],lvl);
            
            if(type == 1)
            ObjectSet(name, OBJPROP_STYLE, STYLE_SOLID);
            else
            ObjectSet(name, OBJPROP_STYLE, STYLE_DOT);
            
            ObjectSet(name, OBJPROP_COLOR, Col);        
            ObjectSet(name,OBJPROP_WIDTH,1);
            ObjectSet(name,OBJPROP_RAY,true);
          
         }
         
   string Obj0002 = name+"linelbl" ;
      ObjectDelete(Obj0002);
      if(ObjectFind(Obj0002) != 0)
      {
         ObjectCreate(Obj0002, OBJ_TEXT, 0, Time[ShiftLabel], lvl);
         ObjectSetText(Obj0002,text , 8, "Arial", Col);
      }
      else
      {
         ObjectMove(Obj0002, 0, Time[ShiftLabel], lvl);
      }          
         
         
}
//+------------------------------------------------------------------+
  
void DoShowHead( int u, color dsColor )
{
string rlabelH = lbl[u] + "Head" ;
ObjectCreate(rlabelH,23,0,Time[0],PRICE_CLOSE);
ObjectSet(rlabelH, OBJPROP_CORNER, myCorner );
ObjectSet(rlabelH,OBJPROP_XDISTANCE, x001+myChartX);
ObjectSet(rlabelH,OBJPROP_YDISTANCE,n+myChartY);
ObjectSetText(rlabelH,lbl2[u],myFontSize,myFont,dsColor);

n = n+20;

return(0);
}
//+------------------------------------------------------------------+
  
void DoShow( int u, color dsColor, double dsPrice, double dsDiff  )
{
ObjectCreate(lbl[u],23,0,Time[0],PRICE_CLOSE);
ObjectSet(lbl[u], OBJPROP_CORNER, myCorner );
ObjectSet(lbl[u],OBJPROP_XDISTANCE,x002+myChartX);
ObjectSet(lbl[u],OBJPROP_YDISTANCE,n+myChartY);
ObjectSetText(lbl[u],lbl2[u],myFontSize,myFont,dsColor);

string Obj001 = lbl[u] + "price" ;
string sVal = fFill(DoubleToStr(dsPrice,digits), 7)    ;
ObjectCreate(Obj001,23,0,Time[0],PRICE_CLOSE);
ObjectSet(Obj001, OBJPROP_CORNER, myCorner );
ObjectSet(Obj001,OBJPROP_XDISTANCE, x003+myChartX);
ObjectSet(Obj001,OBJPROP_YDISTANCE,n+myChartY);
ObjectSetText(Obj001,sVal,myFontSize,myFont,dsColor);


string Obj002 = lbl[u] + "dif" ;
string sDif =  rtadjust( DoubleToStr(dsDiff,0) ) ;
ObjectCreate(Obj002,23,0,Time[0],PRICE_CLOSE);
ObjectSet(Obj002, OBJPROP_CORNER, myCorner );
ObjectSet(Obj002,OBJPROP_XDISTANCE, x004+myChartX);
ObjectSet(Obj002,OBJPROP_YDISTANCE,n+myChartY);
ObjectSetText(Obj002,sDif,myFontSize,myFont,pColor);


n = n+20;

   return(0);
  }


//+------------------------------------------------------------------+
string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN";
   }
   return(tfs);
}

//+------------------------------------------------------------------+
  
void DoColor( double c1, double c2 )
{

if(c1 > c2 ) { pColor = Lime ; } else {
if(c1 < c2 ) { pColor = Red ; } else { pColor = Yellow ; } } 

}   
//+------------------------------------------------------------------+

string fFill(string filled, int f ) 
{
   string FILLED ;
   
   FILLED = StringSubstr(filled + "                                         ",0,f) ;
   
return(FILLED);
}



//+------------------------------------------------------------------+
string rtadjust( string rString )
{
 
 int sl = StringLen(rString) ;
 
 while(true)
 {
 
   if( sl == 5) { break ; } 
   if( sl == 4) { rString = " " + rString ; break ; }    
   if( sl == 3) { rString = "  " + rString ; break ; } 
   if( sl == 2) { rString = "   " + rString ; break ; } 
   if( sl == 1) { rString = "    " + rString ; break ; } 
    
   break ;
 }

return(rString) ;
}       
    

//+------------------------------------------------------------------+
void TRO()
{   
   
   string tObjName03    = "TROTAG"  ;  
   ObjectCreate(tObjName03, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(tObjName03, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(tObjName03, OBJPROP_CORNER, 3);
   ObjectSet(tObjName03, OBJPROP_XDISTANCE, 5 );
   ObjectSet(tObjName03, OBJPROP_YDISTANCE, 5 );  
}


//+------------------------------------------------------------------+ 

