//+------------------------------------------------------------------+
//|                      TRO_ATR_STOP                                |
//|                                                                  | 
//|   Copyright  2008, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|                                                                  |                                         |
//+------------------------------------------------------------------+

// from: http://trader.online.pl/MSZ/e-w-ATR_Trailing_Stop_Loss_I.html

#property copyright "Copyright  2008, Avery T. Horton, Jr. aka TheRumpledOne"
#property link      "therumpledone@gmail.com"

#property indicator_chart_window 
#property indicator_buffers 2

#property indicator_color1 LimeGreen 
#property indicator_color2 Red
#property indicator_color3 Magenta

//---- For the small screens
//extern string    Display_infos         = "=== If true, displayed on the chart ===";
//extern bool      display_on_chart      =  true ;  // If true, the open trade analysis, daily pivots and daily range will be displayed on the chart window

// indicators parameters



//extern int myPeriod  = 1440 ;
extern int myOffset  = 1 ; 
extern int myChartY = 1 ;

extern int myStyle1  = 2 ;
extern int myStyle2  = 2 ;
extern int myStyle3  = 2 ;
extern int myStyle4  = 2 ;
extern int myStyle5  = 2 ;
extern int myStyle6  = 2 ;
extern int myStyle7  = 2 ;

extern int myWingDing1  = 115 ;
extern int myWingDing2  = 115 ;
extern int myWingDing3  = 115 ;
extern int myWingDing4  = 115 ;
extern int myWingDing5  = 115 ;
extern int myWingDing6  = 115 ;
extern int myWingDing7  = 115 ;



//---- buffers

double P1Buffer[];
double P2Buffer[];
double P3Buffer[];
double P4Buffer[];
double P5Buffer[];
double P6Buffer[];
double P7Buffer[];

double yesterday_high=0;
double yesterday_open=0;
double yesterday_low=0;
double yesterday_close=0;
double today_open=0;
double today_high=0;
double today_low=0;


string tHIGH0 = "ATR_SLL" ;
string tLOW0 = "ATR_SLB" ;



//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- name for indicator window

   string short_name="TRO_ATR_STOP";
   IndicatorShortName(short_name);


   SetIndexBuffer(0, P1Buffer);
   SetIndexBuffer(1, P2Buffer);



SetIndexArrow(0, myWingDing1); 
SetIndexArrow(1, myWingDing2); 

 


   SetIndexStyle(0, DRAW_ARROW, myStyle1, 1);
   SetIndexStyle(1, DRAW_ARROW, myStyle2, 1);   


   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   

   ObjectDelete(tHIGH0);
   ObjectDelete(tLOW0);

      
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {

  
   int i, dayi, counted_bars = IndicatorCounted();
//---- check for possible errors
   if(counted_bars < 0) 
       return(-1);
//---- last counted bar will be recounted
   if(counted_bars > 0) 
       counted_bars--;  
   int limit = Bars - counted_bars;
//----   
   for(i = limit - 1; i >= 0; i--)
     {


double H = iHigh(NULL,0,i ) ;
double L = iLow(NULL,0,i) ;			
			
   double X01 = HHV(H - 2.5*ATR(5),10);  
   double X02 = LLV(L + 2.5*ATR(5),10);
 

 
	
//	P1Buffer[i] = X01 ;
//	P2Buffer[i] = X02 ;


 }



  if (ObjectFind(tHIGH0) != 0)
      {
      
//          ObjectCreate(tHIGH0,OBJ_HLINE,0,Time[0],X01);         
          ObjectCreate(tHIGH0,OBJ_ARROW,0,Time[0],X01);
          ObjectSet(tHIGH0,OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet(tHIGH0,OBJPROP_COLOR,indicator_color1);  
      } 
      else
      {
         ObjectMove(tHIGH0,0,Time[0],X01);
      }
 

    
    if (ObjectFind(tLOW0) != 0)
      {
          ObjectCreate(tLOW0,OBJ_ARROW,0,Time[0],X02);
          ObjectSet(tLOW0,OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet(tLOW0,OBJPROP_COLOR,indicator_color2);  
      } 
      else
      {
         ObjectMove(tLOW0,0,Time[0],X02);
      }

 
    
   return(0);
  }


