//+------------------------------------------------------------------+ 
//|   TRO_BuyZone_Time                                               | 
//|                                                                  | 
//|   Copyright  2009, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+ 
//| Use http://therumpledone.mbtrading.com/fx/ as your forex broker  |  
//| ...tell them therumpledone sent you!                             |  
//+------------------------------------------------------------------+ 


#property  copyright "Copyright  2009, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 

#property indicator_chart_window 
 
 

extern bool   show.comment   = true ;
extern bool   Show.PriceBox  = true ;
extern bool   Show.Lines     = true ;
extern bool   Show.Label     = true ;
extern int    ShiftLabel     =  10 ;


extern int    myBoxWidth     = 2;
extern int    myLineStyle    = STYLE_DOT;
extern int    myLineWidth    = 1;

extern string myHHMM1     = "01:00" ; 


extern double myEntryTrigger   = 50 ;
extern double myProfitTarget   = 100 ;
extern double myStopLoss       = 10 ;

extern color colorOpen         = Purple ;
extern color colorTarget       = Green ;
extern color colorBuy          = Blue ;
extern color colorShort        = Red ;
extern color colorStop         = Magenta ;
//+------------------------------------------------------------------+ 

double OpenLine,DailyOpen; 
double BuyLine1 ; 
double BuyLine2 ; 
double SellLine1 ; 
double SellLine2 ; 
double TargetLine1 ; 
double TargetLine2 ; 
double StopLine1 ; 
double StopLine2 ; 

//+------------------------------------------------------------------+ 
string symbol, tChartPeriod,  tShortName ;  
int    digits2, digits, period, win ; 
double point;


int      cd ;

string   HHMM, SessionName, thisHHMM ;

double PipsToOpen, C ;

//+------------------------------------------------------------------+ 
int init() 
  { 

   period       =  Period() ;   
   tChartPeriod =  TimeFrameToString(period) ;  
   digits       =  Digits ;
   point        =  Point ; 
   symbol       =  Symbol() ; 
   tShortName   =  symbol + tChartPeriod + myHHMM1  ; 
    

   if(digits == 5 || digits == 3) { digits = digits - 1 ; point = point * 10 ; }   
   
   deinit();      
 
   return(0); 
  } 
  

//+------------------------------------------------------------------+

void ObDeleteObjectsByPrefix(string Prefix)
  {
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal())
     {
       string ObjName = ObjectName(i);
       if(StringSubstr(ObjName, 0, L) != Prefix) 
         { 
           i++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
  }
    
//+------------------------------------------------------------------+

int deinit()
  {
   
   
   ObDeleteObjectsByPrefix(symbol);  //"%ChangeCW"
   
   TRO() ;
   
   Comment("") ;
   
   return(0);
  }
    
  
//+------------------------------------------------------------------+ 
int start() 
{ 
    DoDailyOpen(symbol) ; 

    OpenLine    = DailyOpen; 

    BuyLine1    = OpenLine + myEntryTrigger*point;  
    SellLine1   = OpenLine - myEntryTrigger*point; 

    StopLine1   = BuyLine1 - myStopLoss*point;  
    StopLine2   = SellLine1 + myStopLoss*point; 
 
    TargetLine1 = OpenLine + myProfitTarget*point; 
    TargetLine2 = OpenLine - myProfitTarget*point;    
 
      DrawPriceTrendLines(tShortName+"bzop" , Time[cd], Time[0], DailyOpen, 
                        DailyOpen, colorOpen, myLineStyle, myLineWidth) ; 


      DrawPriceTrendLines(tShortName+"bzbuy1" , Time[cd], Time[0], BuyLine1, 
                        BuyLine1, colorBuy, myLineStyle, myLineWidth) ; 

      DrawPriceTrendLines(tShortName+"bzsell1" , Time[cd], Time[0], SellLine1, 
                        SellLine1, colorShort, myLineStyle, myLineWidth) ; 

      DrawPriceTrendLines(tShortName+"bztgt1" , Time[cd], Time[0], TargetLine1, 
                        TargetLine1, colorTarget, myLineStyle, myLineWidth) ; 

      DrawPriceTrendLines(tShortName+"bztgt2" , Time[cd], Time[0], TargetLine2, 
                        TargetLine2, colorTarget, myLineStyle, myLineWidth) ; 

      DrawPriceTrendLines(tShortName+"bzStop1" , Time[cd], Time[0], StopLine1, 
                        StopLine1, colorStop, myLineStyle, myLineWidth) ; 

      DrawPriceTrendLines(tShortName+"bzStop2" , Time[cd], Time[0], StopLine2, 
                        StopLine2, colorStop, myLineStyle, myLineWidth) ; 
 
  ObjectDelete(tShortName+"left");
  ObjectCreate(tShortName+"left", OBJ_VLINE, 0, Time[cd], 0);
  ObjectSet(tShortName+"left", OBJPROP_STYLE, myLineStyle);
  ObjectSet(tShortName+"left", OBJPROP_COLOR,colorOpen );
   
  if(Show.PriceBox) { DoBox() ; }

   if( show.comment )
   {
      PipsToOpen = ( Close[0] - OpenLine ) / point ;
   
      Comment( 
         "\n",
         "Open Time... ", myHHMM1, "\n", 
         "\n",
         "LgTarget.... ", DoubleToStr(TargetLine1,digits) , "\n",  
         "LgTrigger... ", DoubleToStr(BuyLine1,digits) ,"\n", 
         "LgStopLine.. ", DoubleToStr(StopLine1,digits) ,"\n",  
         "\n",
         "OpenLine.... ", DoubleToStr(OpenLine,digits) ,"\n",    
         "\n", 
         "ShStopLine.. ", DoubleToStr(StopLine2,digits) ,"\n",                         
         "ShTrigger... ", DoubleToStr(SellLine1,digits) , "\n",                  
         "ShTarget.... ", DoubleToStr(TargetLine2,digits) , "\n",    
         "\n", 
         "Pips to Open ", DoubleToStr(PipsToOpen,0) , "\n",             
                     
         "") ;
   }

return(0); 
}  
  
//+--------- TRO MODIFICATION ---------------------------------------+  
void DoBox()    
{

      if (ObjectFind(tShortName+"01") != 0)
      {
          ObjectCreate(tShortName+"01",OBJ_ARROW,0,Time[0],TargetLine1);
          ObjectSet(tShortName+"01",OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet(tShortName+"01",OBJPROP_COLOR,colorTarget);  
          ObjectSet(tShortName+"01",OBJPROP_WIDTH,myBoxWidth);  
      } 
      else
      {
         ObjectMove(tShortName+"01",0,Time[0],TargetLine1);
         ObjectSet(tShortName+"01",OBJPROP_COLOR,colorTarget);  
      }

      if (ObjectFind(tShortName+"02") != 0)
      {
          ObjectCreate(tShortName+"02",OBJ_ARROW,0,Time[0],BuyLine1);
          ObjectSet(tShortName+"02",OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet(tShortName+"02",OBJPROP_COLOR,colorBuy);  
          ObjectSet(tShortName+"02",OBJPROP_WIDTH,myBoxWidth);  
      } 
      else
      {
         ObjectMove(tShortName+"02",0,Time[0],BuyLine1);
         ObjectSet(tShortName+"02",OBJPROP_COLOR,colorBuy);  
      }

 
      if (ObjectFind(tShortName+"03") != 0)
      {
          ObjectCreate(tShortName+"03",OBJ_ARROW,0,Time[0],OpenLine);
          ObjectSet(tShortName+"03",OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet(tShortName+"03",OBJPROP_COLOR,colorOpen);  
          ObjectSet(tShortName+"03",OBJPROP_WIDTH,myBoxWidth);  
      } 
      else
      {
         ObjectMove(tShortName+"03",0,Time[0],OpenLine);
         ObjectSet(tShortName+"03",OBJPROP_COLOR,colorOpen);  
      }
 
      if (ObjectFind(tShortName+"04") != 0)
      {
          ObjectCreate(tShortName+"04",OBJ_ARROW,0,Time[0],SellLine1);
          ObjectSet(tShortName+"04",OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet(tShortName+"04",OBJPROP_COLOR,colorShort);  
          ObjectSet(tShortName+"04",OBJPROP_WIDTH,myBoxWidth);  
      } 
      else
      {
         ObjectMove(tShortName+"04",0,Time[0],SellLine1);
         ObjectSet(tShortName+"04",OBJPROP_COLOR,colorShort);  
      }

      
      if (ObjectFind(tShortName+"05") != 0)
      {
          ObjectCreate(tShortName+"05",OBJ_ARROW,0,Time[0],TargetLine2);
          ObjectSet(tShortName+"05",OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet(tShortName+"05",OBJPROP_COLOR,colorTarget);  
          ObjectSet(tShortName+"05",OBJPROP_WIDTH,myBoxWidth);  
      } 
      else
      {
         ObjectMove(tShortName+"05",0,Time[0],TargetLine2);
         ObjectSet(tShortName+"05",OBJPROP_COLOR,colorTarget);  
      }
     
      if (ObjectFind(tShortName+"06") != 0)
      {
          ObjectCreate(tShortName+"06",OBJ_ARROW,0,Time[0],StopLine1);
          ObjectSet(tShortName+"06",OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet(tShortName+"06",OBJPROP_COLOR,colorStop);  
          ObjectSet(tShortName+"06",OBJPROP_WIDTH,myBoxWidth);  
      } 
      else
      {
         ObjectMove(tShortName+"06",0,Time[0],StopLine1);
         ObjectSet(tShortName+"06",OBJPROP_COLOR,colorStop);  
      } 

      if (ObjectFind(tShortName+"07") != 0)
      {
          ObjectCreate(tShortName+"07",OBJ_ARROW,0,Time[0],StopLine2);
          ObjectSet(tShortName+"07",OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet(tShortName+"07",OBJPROP_COLOR,colorStop);  
          ObjectSet(tShortName+"07",OBJPROP_WIDTH,myBoxWidth);  
      } 
      else
      {
         ObjectMove(tShortName+"07",0,Time[0],StopLine2);
         ObjectSet(tShortName+"07",OBJPROP_COLOR,colorStop);  
      }    
      
                      
   return(0);
}


//+------------------------------------------------------------------+ 

 

void DoDailyOpen(string doSymbol) 
{

int   yy = TimeYear(Time[0]);
int   mm = TimeMonth(Time[0]);
int   dd = TimeDay(Time[0]);  
   
string yymmddms = yy+"."+mm+"."+dd+" " + myHHMM1 ;
         
datetime var1 = StrToTime(yymmddms);  
   
datetime day=24*60*60;
datetime r= var1 ;

//datetime r=(TimeCurrent()/day)*day;
//datetime r=(var1/day)*day;

         cd=iBarShift(NULL,0,r,FALSE);
datetime r2=r-day;


if(TimeDayOfWeek(r2)==0) r2=r2-day-day;
int cd2=iBarShift(NULL,0,r2,FALSE);

if( var1 > Time[0] ) { r = r2 ;cd = cd2 ;} // if date/time is greater than current date/time go back 1 day


DailyOpen = iOpen(doSymbol,0,cd);    

//barstouse = ChartPeriod * cd ;

}
 
//+------------------------------------------------------------------+
 

void DrawPriceTrendLines(string objname, datetime x1, datetime x2, double y1, 
                        double y2, color lineColor, int style, int width)
  {
    
   ObjectDelete(objname);
   ObjectCreate(objname, OBJ_TREND, 0, x1, y1, x2, y2, 0, 0);
   ObjectSet(objname, OBJPROP_RAY, false);
 
   ObjectSet(objname, OBJPROP_COLOR, lineColor);
   ObjectSet(objname, OBJPROP_STYLE, style);
   ObjectSet(objname, OBJPROP_WIDTH, width);


   if(Show.Label && y1 == y2)
   {
   string Obj0002 = objname+"linelbl" ;
      ObjectDelete(Obj0002);
      if(ObjectFind(Obj0002) != 0)
      {
         ObjectCreate(Obj0002, OBJ_TEXT, 0, Time[ShiftLabel], y1); // Time[ShiftLabel]
         ObjectSetText(Obj0002, DoubleToStr(y1 ,digits) , 8, "Arial", lineColor);
      }
      else
      {
         ObjectMove(Obj0002, 0, Time[ShiftLabel], y1); // Time[ShiftLabel]
      } // if  

   }// if
   
  } // void
  
//+--------- TRO MODIFICATION ---------------------------------------+  

string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN";
   }
   return(tfs);
}

//+------------------------------------------------------------------+  
void TRO()
{   
   
   string tObjName03    = "TROTAG"  ;  
   ObjectCreate(tObjName03, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(tObjName03, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(tObjName03, OBJPROP_CORNER, 3);
   ObjectSet(tObjName03, OBJPROP_XDISTANCE, 5 );
   ObjectSet(tObjName03, OBJPROP_YDISTANCE, 5 );  
} 

//+--------- TRO MODIFICATION ---------------------------------------+  