//+------------------------------------------------------------------+ 
//|   TRO_RANGE                                                      | 
//|                                                                  | 
//|   Copyright  2009, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+ 
//| Use http://therumpledone.mbtrading.com/fx/ as your forex broker  |  
//| ...tell them therumpledone sent you!                             |  
//+------------------------------------------------------------------+ 


#property  copyright "Copyright  2009, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 
 

//---- indicator settings 
#property  indicator_separate_window 
#property  indicator_buffers 3 
#property  indicator_color1  Red 
#property  indicator_color2  Green 
#property  indicator_color3  Orange 

extern bool Show.Message = true ;
extern int myCorner= 1;
extern int x.offset= 80 ; 
extern int y.offset= 10 ; 

extern string myFont       = "Arial Bold" ;
extern int    myFontSize   = 12 ;

extern int   AvgBars         = 24 ; 
extern double   Threshold       = 20.0 ; 
extern color CurrentBarColor = Blue; 
extern color ThresholdColor  = Aqua; 
extern color AverageColor    = Orange; 

extern int    myBarWidth      = 2 ;

//+------------------------------------------------------------------+ 
   double HighVal,LowVal; 
   int limit; 
   
double     RANGEBuffer[]; 
double     RANGEBuffer1[]; 
double     AvgRANGEBuffer[]; 

string symbol, tChartPeriod,  tShortName, TAG, tObjName05,tObjName06, tMessage, tAlert, short_name ;  
int    i, digits, period, digits2,win  ; 
double point ;

double range, Pct, AvgPct;

color TheColor    = Blue; 

//+------------------------------------------------------------------+ 
int init() 
{ 
   period       =  Period() ;    
   symbol       =  Symbol() ;
   digits       =  Digits ;   
   point        =  Point ;


   if(digits == 5 || digits == 3) { digits = digits - 1 ; point = point * 10 ; }   
    
 
   SetIndexBuffer(0,RANGEBuffer); 
   SetIndexBuffer(1,RANGEBuffer1);  
   SetIndexBuffer(2,AvgRANGEBuffer);  
    

   SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID, myBarWidth, CurrentBarColor); 
   SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_SOLID, myBarWidth, ThresholdColor); 
   SetIndexStyle(2,DRAW_LINE,STYLE_SOLID, myBarWidth, AverageColor);     

 
   SetIndexLabel(0,"RANGE"); 
   SetIndexLabel(1,"RANGE"); 
   SetIndexLabel(2,"AvgRANGE"); 
   
   SetLevelStyle(STYLE_DOT, 1, DimGray) ;
   SetLevelValue(1,Threshold);


      short_name = "Range" ;
      IndicatorShortName(short_name);
      
      TAG = "Range" ;

      tObjName05 = TAG + "05" ; 
      tObjName06 = TAG + "06" ; 
      
      deinit() ;
       
   return(0); 
  } 

//+------------------------------------------------------------------+
 

void ObDeleteObjectsByPrefix(string Prefix)
  {
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal())
     {
       string ObjName = ObjectName(i);
       if(StringSubstr(ObjName, 0, L) != Prefix) 
         { 
           i++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
  }  
//+------------------------------------------------------------------+
int deinit()
  {
       
   ObDeleteObjectsByPrefix(TAG); 
   
   TRO() ;   
   return(0);
  } 
 
//+------------------------------------------------------------------+ 
int start() 
{ 
  
   win =    WindowFind(short_name);  
   

   int counted_bars=IndicatorCounted(); 
   
  if(counted_bars>0) counted_bars--; 
  
  limit=Bars-counted_bars; 
  
//---- RANGE counted in the 1-st buffer 

   for(i = limit; i >= 0; i--)
   { 
     HighVal  = iHigh(NULL,0,i);        
     LowVal   = iLow(NULL,0,i); 
     range    = (HighVal-LowVal) / point ;
     
     RANGEBuffer[i] = range;
     
     if (range >= Threshold) { RANGEBuffer1[i] = range; } 
     
        
   } // for
      
     
   for(i = limit; i >= 0; i--)
   {     
      AvgRANGEBuffer[i] = iMAOnArray(RANGEBuffer,0,AvgBars,0,0,i);     
   } // for
        
//----

    if(Show.Message) { DoShowMessage(); }   
          
    WindowRedraw() ;
//----
   return(0);
  }


//+------------------------------------------------------------------+

void DoShowMessage()
{
   
   tMessage = DoubleToStr(RANGEBuffer[0],0) + " Range" ;
   
   TheColor = CurrentBarColor ;
   
   if( RANGEBuffer[0] > 0 ) { Pct = 100 + 100 * ( RANGEBuffer[0] - RANGEBuffer[1] ) / RANGEBuffer[1] ; }
   else { Pct = 0 ; }
   
   Pct  = MathAbs(Pct) ;
      

   tAlert = DoubleToStr(Pct,0) + "% Prev " + DoubleToStr(RANGEBuffer[1],0) + " Pips | ";  
   
   if(RANGEBuffer[0] > Threshold)         { TheColor = ThresholdColor ; tMessage = tMessage + " Above " + DoubleToStr(Threshold,0) + " Pips | " ;  }
 
   if(RANGEBuffer[0] > AvgRANGEBuffer[0]) { TheColor = AverageColor   ; tMessage = tMessage + " Above Average " + DoubleToStr(AvgRANGEBuffer[0],0) + " Pips "; }
   
 
   if( AvgRANGEBuffer[0] > 0 ) { AvgPct = 100 + 100 * ( RANGEBuffer[0] - AvgRANGEBuffer[0] ) / AvgRANGEBuffer[0] ; }
   else { AvgPct = 0 ; }
   
   AvgPct  = MathAbs(AvgPct) ;
      

   tAlert = tAlert + DoubleToStr(AvgPct,0) + "% Avg("+AvgBars+") " + DoubleToStr(AvgRANGEBuffer[0],0) ;


   ObjectCreate(tObjName05, OBJ_LABEL, win, 0, 0);// 
   ObjectSetText(tObjName05, tMessage , myFontSize, myFont, TheColor );  
   ObjectSet(tObjName05, OBJPROP_CORNER, 1);
   ObjectSet(tObjName05, OBJPROP_XDISTANCE, -70 + x.offset); // myCorner
   ObjectSet(tObjName05, OBJPROP_YDISTANCE,  y.offset); //     
 

   ObjectCreate(tObjName06, OBJ_LABEL, win, 0, 0);// 
   ObjectSetText(tObjName06, tAlert , myFontSize, myFont, TheColor );  
   ObjectSet(tObjName06, OBJPROP_CORNER, 1);
   ObjectSet(tObjName06, OBJPROP_XDISTANCE, -70 + x.offset); // myCorner
   ObjectSet(tObjName06, OBJPROP_YDISTANCE, 20+ y.offset); //     
 
 
} // void
//+------------------------------------------------------------------+  
 
 
//+------------------------------------------------------------------+  
void TRO()
{   
   
   string tObjName03    = "TROTAG"  ;  
   ObjectCreate(tObjName03, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(tObjName03, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(tObjName03, OBJPROP_CORNER, 3);
   ObjectSet(tObjName03, OBJPROP_XDISTANCE, 5 );
   ObjectSet(tObjName03, OBJPROP_YDISTANCE, 5 );  
}  
//+------------------------------------------------------------------+

/*
   setObject(TAG+"CH","Climax High " ,30,yInc+20,ClimaxHighColor); setObject(TAG+"CH1",Arrow ,11,yInc+21,ClimaxHighColor     ,"Wingdings");
     
   setObject(TAG+"NE","Neutral     " ,30,yInc+33,NeutralColor); setObject(TAG+"NE1",Arrow ,11,yInc+34,NeutralColor     ,"Wingdings");

   setObject(TAG+"LO","Low         " ,30,yInc+46,LowColor); setObject(TAG+"LO1",Arrow ,11,yInc+46,LowColor,"Wingdings");
  
   setObject(TAG+"HI","High        ",30,yInc+59,HighChurnColor); setObject(TAG+"HI1",Arrow ,11,yInc+59,HighChurnColor,"Wingdings");

   setObject(TAG+"CL","Climax Low  " ,30,yInc+72,ClimaxLowColor); setObject(TAG+"CL1",Arrow ,11,yInc+72,ClimaxLowColor,"Wingdings");
  
   setObject(TAG+"CC","Climax Churn",30,yInc+85,ClimaxChurnColor); setObject(TAG+"CC1",Arrow ,11,yInc+85,ClimaxChurnColor,"Wingdings");
     

Comment(
"RANGEBuffer[1]= ", DoubleToStr(RANGEBuffer[1],Digits) , "\n", 
"AvgRANGEBuffer[1]= ", DoubleToStr(AvgRANGEBuffer[1],Digits) , "\n",  
"") ;  
 

*/